Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs	(revision 14744)
@@ -22,10 +22,12 @@
   [PushExpression(StackType.Code, "CODE.DO")]
   public class CodeDoExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       // not enough arguments on stack
-      if (interpreter.CodeStack.Count == 0) return;
+      if (interpreter.CodeStack.Count == 0) return false;
 
       var codePopExpression = ExpressionTable.GetStatelessExpression<CodePopExpression>();
       interpreter.ExecStack.Push(codePopExpression, interpreter.CodeStack.Top);
+
+      return true;
     }
   }
@@ -36,10 +38,12 @@
   [PushExpression(StackType.Code, "CODE.DO*")]
   public class CodeDoXExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       // not enough arguments on stack
-      if (interpreter.CodeStack.Count == 0) return;
+      if (interpreter.CodeStack.Count == 0) return false;
 
       var expression = interpreter.CodeStack.Pop();
       interpreter.ExecStack.Push(expression);
+
+      return true;
     }
   }
@@ -50,6 +54,6 @@
   [PushExpression(StackType.Code, "CODE.NOOP")]
   public class CodeNoopExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      // nothing to do
+    public override bool Eval(IPushInterpreter interpreter) {
+      return false;
     }
   }
@@ -61,10 +65,12 @@
   [PushExpression(StackType.Code, "CODE.QUOTE")]
   public class CodeQuoteExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       // not enough arguments on stack
-      if (interpreter.ExecStack.Count == 0) return;
+      if (interpreter.ExecStack.Count == 0) return false;
 
       var expression = interpreter.ExecStack.Pop();
       interpreter.CodeStack.Push(expression);
+
+      return true;
     }
   }
@@ -77,7 +83,7 @@
   [PushExpression(StackType.Code, "CODE.IF")]
   public class CodeIfExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       // not enough arguments on stack
-      if ((interpreter.BooleanStack.Count == 0) || (interpreter.CodeStack.Count < 2)) return;
+      if ((interpreter.BooleanStack.Count == 0) || (interpreter.CodeStack.Count < 2)) return false;
 
       var condition = interpreter.BooleanStack.Pop();
@@ -85,4 +91,6 @@
 
       interpreter.ExecStack.Push(condition ? items[0] : items[1]);
+
+      return true;
     }
   }
@@ -94,6 +102,6 @@
   [PushExpression(StackType.Code, "CODE.APPEND")]
   public class CodeAppendExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.CodeStack.Count < 2) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.CodeStack.Count < 2) return false;
 
       var first = interpreter.CodeStack.Pop();
@@ -113,5 +121,5 @@
 
           // if size > maxPointsInProgram this expressions results in a NOOP
-          if (size > interpreter.Configuration.MaxPointsInProgram) return;
+          if (size > interpreter.Configuration.MaxPointsInProgram) return false;
 
           result = new Expression[size];
@@ -128,5 +136,5 @@
 
           // if size > maxPointsInProgram this expressions results in a NOOP
-          if (size > interpreter.Configuration.MaxPointsInProgram) return;
+          if (size > interpreter.Configuration.MaxPointsInProgram) return false;
 
           result = new Expression[size];
@@ -141,5 +149,5 @@
 
         // if size > maxPointsInProgram this expressions results in a NOOP
-        if (size > interpreter.Configuration.MaxPointsInProgram) return;
+        if (size > interpreter.Configuration.MaxPointsInProgram) return false;
 
         result = new Expression[size];
@@ -154,4 +162,6 @@
 
       interpreter.CodeStack.SetTop(expression);
+
+      return true;
     }
   }
@@ -163,6 +173,6 @@
   [PushExpression(StackType.Code, "CODE.ATOM")]
   public class CodeAtomExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.CodeStack.Count == 0) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.CodeStack.Count == 0) return false;
 
       var expression = interpreter.CodeStack.Pop();
@@ -170,4 +180,5 @@
 
       interpreter.BooleanStack.Push(!isExpandExpression);
+      return true;
     }
   }
@@ -181,14 +192,15 @@
   [PushExpression(StackType.Code, "CODE.CAR")]
   public class CodeCarExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if ((interpreter.CodeStack.Count == 0) || (interpreter.CodeStack.Top.GetType() !=
-                                                 typeof(ExecExpandExpression))) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if ((interpreter.CodeStack.Count == 0) ||
+          (interpreter.CodeStack.Top.GetType() != typeof(ExecExpandExpression))) return false;
 
       var expand = interpreter.CodeStack.Top as ExecExpandExpression;
 
-      if (expand.State.IsEmpty) return;
+      if (expand.State.IsEmpty) return false;
       var first = expand.State.Expressions[expand.State.Expressions.Count - 1];
 
       interpreter.CodeStack.SetTop(first);
+      return true;
     }
   }
@@ -202,8 +214,8 @@
   [PushExpression(StackType.Code, "CODE.CDR")]
   public class CodeCdrExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.CodeStack.Count == 0) return;
-
-      Expression expandExpression = null;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.CodeStack.Count == 0) return false;
+
+      ExecExpandExpression expandExpression;
       var top = interpreter.CodeStack.Top;
 
@@ -211,5 +223,5 @@
         var expand = (ExecExpandExpression)top;
 
-        if (expand.State.IsEmpty) return;
+        if (expand.State.IsEmpty) return false;
         var length = expand.State.Expressions.Count - 1;
         var newExpressions = new Expression[length];
@@ -223,4 +235,5 @@
 
       interpreter.CodeStack.SetTop(expandExpression);
+      return true;
     }
   }
@@ -233,7 +246,7 @@
   [PushExpression(StackType.Code, "CODE.CONS")]
   public class CodeConsExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       if (interpreter.CodeStack.Count < 2)
-        return;
+        return false;
 
       ExecExpandExpression result;
@@ -243,5 +256,5 @@
         var size = first.State.Expressions.Count + 1;
 
-        if (size > interpreter.Configuration.MaxPointsInProgram) return;
+        if (size > interpreter.Configuration.MaxPointsInProgram) return false;
 
         var expressions = new Expression[size];
@@ -256,4 +269,5 @@
 
       interpreter.CodeStack.SetTop(result);
+      return true;
     }
   }
@@ -269,8 +283,8 @@
   [PushExpression(StackType.Code, "CODE.CONTAINER")]
   public class CodeContainerExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       if ((interpreter.CodeStack.Count < 2) ||
           (interpreter.CodeStack[interpreter.CodeStack.Count - 2].GetType() !=
-           typeof(ExecExpandExpression))) return;
+           typeof(ExecExpandExpression))) return false;
 
       var target = interpreter.CodeStack.Pop();
@@ -281,4 +295,5 @@
 
       interpreter.CodeStack.SetTop(result);
+      return true;
     }
 
@@ -307,8 +322,8 @@
   [PushExpression(StackType.Code, "CODE.CONTAINS")]
   public class CodeContainsExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       if (interpreter.CodeStack.Count < 2 ||
          !interpreter.CodeStack[interpreter.CodeStack.Count - 2].CanExpand)
-        return;
+        return false;
 
       var values = interpreter.CodeStack.Pop(2);
@@ -317,4 +332,6 @@
 
       interpreter.BooleanStack.Push(contains);
+
+      return true;
     }
   }
@@ -327,7 +344,7 @@
   [PushExpression(StackType.Code, "CODE.DEFINITION")]
   public class CodeDefinitionExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       if ((interpreter.NameStack.Count == 0) ||
-          !interpreter.CustomExpressions.ContainsKey(interpreter.NameStack.Top)) return;
+          !interpreter.CustomExpressions.ContainsKey(interpreter.NameStack.Top)) return false;
 
       var name = interpreter.NameStack.Pop();
@@ -335,4 +352,6 @@
 
       interpreter.CodeStack.Push(definition);
+
+      return true;
     }
   }
@@ -363,6 +382,6 @@
   [PushExpression(StackType.Code, "CODE.DISCREPANCY")]
   public class CodeDiscrepancyExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.CodeStack.Count < 2) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.CodeStack.Count < 2) return false;
 
       var expressions = interpreter.CodeStack.Pop(2);
@@ -376,4 +395,6 @@
 
       interpreter.IntegerStack.Push(discrepancy);
+
+      return true;
     }
 
@@ -418,9 +439,9 @@
   [PushExpression(StackType.Code, "CODE.EXTRACT")]
   public class CodeExtractExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       if (interpreter.IntegerStack.Count == 0 ||
           interpreter.CodeStack.Count == 0 ||
           !interpreter.CodeStack.Top.CanExpand)
-        return;
+        return false;
 
       var expression = (ExecExpandExpression)interpreter.CodeStack.Top;
@@ -429,4 +450,6 @@
 
       interpreter.CodeStack.SetTop(result);
+
+      return true;
     }
   }
@@ -437,6 +460,6 @@
   [PushExpression(StackType.Code, "CODE.FROMBOOLEAN")]
   public class CodeFromBooleanExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.BooleanStack.Count == 0) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.BooleanStack.Count == 0) return false;
 
       var value = interpreter.BooleanStack.Pop();
@@ -444,4 +467,6 @@
 
       interpreter.CodeStack.Push(expression);
+
+      return true;
     }
   }
@@ -452,6 +477,6 @@
   [PushExpression(StackType.Code, "CODE.FROMFLOAT")]
   public class CodeFromFloatExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.FloatStack.Count == 0) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.FloatStack.Count == 0) return false;
 
       var value = interpreter.FloatStack.Pop();
@@ -459,4 +484,6 @@
 
       interpreter.CodeStack.Push(expression);
+
+      return true;
     }
   }
@@ -467,6 +494,6 @@
   [PushExpression(StackType.Code, "CODE.FROMINTEGER")]
   public class CodeFromIntegerExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.IntegerStack.Count == 0) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.IntegerStack.Count == 0) return false;
 
       var value = interpreter.IntegerStack.Pop();
@@ -474,4 +501,6 @@
 
       interpreter.CodeStack.Push(expression);
+
+      return true;
     }
   }
@@ -482,6 +511,6 @@
   [PushExpression(StackType.Code, "CODE.FROMNAME")]
   public class CodeFromNameExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.NameStack.Count == 0) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.NameStack.Count == 0) return false;
 
       var value = interpreter.NameStack.Pop();
@@ -489,4 +518,6 @@
 
       interpreter.CodeStack.Push(expression);
+
+      return true;
     }
   }
@@ -498,9 +529,9 @@
   [PushExpression(StackType.Code, "CODE.CODEINSERT")]
   public class CodeInsertExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       if (interpreter.IntegerStack.Count == 0 ||
           interpreter.CodeStack.Count < 2 ||
           !interpreter.CodeStack.Top.CanExpand)
-        return;
+        return false;
 
       var source = interpreter.CodeStack[interpreter.CodeStack.Count - 2];
@@ -522,4 +553,6 @@
       var result = new ExecExpandExpression(newExpressions);
       interpreter.CodeStack.SetTop(result);
+
+      return true;
     }
   }
@@ -533,6 +566,6 @@
   [PushExpression(StackType.Code, "CODE.LENGTH")]
   public class CodeLengthExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.CodeStack.Count == 0) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.CodeStack.Count == 0) return false;
 
       var expression = interpreter.CodeStack.Pop();
@@ -543,4 +576,6 @@
 
       interpreter.IntegerStack.Push(count);
+
+      return true;
     }
   }
@@ -551,6 +586,6 @@
   [PushExpression(StackType.Code, "CODE.LIST")]
   public class CodeListExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.CodeStack.Count < 2) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.CodeStack.Count < 2) return false;
 
       var first = interpreter.CodeStack.Pop();
@@ -559,4 +594,6 @@
 
       interpreter.CodeStack.SetTop(expandExpression);
+
+      return true;
     }
   }
@@ -568,6 +605,6 @@
   [PushExpression(StackType.Code, "CODE.MEMBER")]
   public class CodeMemberExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.CodeStack.Count < 2) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.CodeStack.Count < 2) return false;
 
       var expressions = interpreter.CodeStack.Pop(2);
@@ -578,4 +615,6 @@
 
       interpreter.BooleanStack.Push(contains);
+
+      return true;
     }
   }
@@ -588,11 +627,11 @@
   [PushExpression(StackType.Code, "CODE.NTH")]
   public class CodeNthExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if ((interpreter.CodeStack.Count == 0) || (interpreter.IntegerStack.Count == 0)) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if ((interpreter.CodeStack.Count == 0) || (interpreter.IntegerStack.Count == 0)) return false;
 
       var n = interpreter.IntegerStack.Pop();
       var expression = interpreter.CodeStack.Top;
 
-      Expression nthExpression = null;
+      Expression nthExpression;
 
       if (expression.CanExpand) {
@@ -612,4 +651,6 @@
 
       interpreter.CodeStack.SetTop(nthExpression);
+
+      return true;
     }
   }
@@ -625,6 +666,6 @@
   [PushExpression(StackType.Code, "CODE.NTHCDR")]
   public class CodeNthCdrExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if ((interpreter.CodeStack.Count == 0) || (interpreter.IntegerStack.Count == 0)) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if ((interpreter.CodeStack.Count == 0) || (interpreter.IntegerStack.Count == 0)) return false;
 
       var n = interpreter.IntegerStack.Pop();
@@ -648,4 +689,6 @@
 
       interpreter.CodeStack.SetTop(nthExpression);
+
+      return true;
     }
   }
@@ -656,10 +699,11 @@
   [PushExpression(StackType.Code, "CODE.NULL")]
   public class CodeNullExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.CodeStack.Count == 0) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.CodeStack.Count == 0) return false;
 
       var result = interpreter.CodeStack.Pop().Equals(ExecExpandExpression.Empty);
-
       interpreter.BooleanStack.Push(result);
+
+      return true;
     }
   }
@@ -671,6 +715,6 @@
   [PushExpression(StackType.Code, "CODE.POSITION")]
   public class CodePositionExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.CodeStack.Count < 2) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.CodeStack.Count < 2) return false;
 
       var expressions = interpreter.CodeStack.Pop(2);
@@ -688,4 +732,6 @@
 
       interpreter.IntegerStack.Push(position);
+
+      return true;
     }
   }
@@ -697,6 +743,6 @@
   [PushExpression(StackType.Code, "CODE.SIZE")]
   public class CodeSizeExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.CodeStack.Count == 0) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.CodeStack.Count == 0) return false;
 
       var expression = interpreter.CodeStack.Pop();
@@ -706,4 +752,6 @@
 
       interpreter.IntegerStack.Push(points);
+
+      return true;
     }
   }
@@ -717,7 +765,7 @@
   [PushExpression(StackType.Code, "CODE.SUBST")]
   public class CodeSubstitutionExpression : StatelessExpression {
-    public override void Eval(IPushInterpreter interpreter) {
+    public override bool Eval(IPushInterpreter interpreter) {
       if ((interpreter.CodeStack.Count < 3) || (interpreter.CodeStack.Top.GetType() !=
-                                                typeof(ExecExpandExpression))) return;
+                                                typeof(ExecExpandExpression))) return false;
 
       var expressions = interpreter.CodeStack.Pop(2);
@@ -736,4 +784,6 @@
 
       interpreter.CodeStack.SetTop(result);
+
+      return true;
     }
   }
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DefineExpressions.cs	(revision 14744)
@@ -3,7 +3,7 @@
   using System.Collections.Generic;
 
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Attributes;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Interpreter;
-  using HeuristicLab.Problems.ProgramSynthesis.Push.Stack;
+  using Attributes;
+  using Interpreter;
+  using Stack;
 
   /// <summary>
@@ -13,5 +13,5 @@
   /// <typeparam name="T">Stacktype</typeparam>
   public abstract class DefineExpression<T> : StatelessExpression {
-    protected void Eval(
+    protected bool Eval(
       IStack<T> stack,
       IStack<string> nameStack,
@@ -19,5 +19,5 @@
       Func<T, Expression> creator) {
       // not enough arguments on stack
-      if ((nameStack.Count == 0) || (stack.Count < 1)) return;
+      if ((nameStack.Count == 0) || (stack.Count < 1)) return false;
 
       var name = nameStack.Pop();
@@ -26,4 +26,6 @@
       if (customExpressions.ContainsKey(name)) customExpressions[name] = expression;
       else customExpressions.Add(name, expression);
+
+      return true;
     }
   }
@@ -31,6 +33,6 @@
   [PushExpression(StackType.Code, "CODE.DEFINE")]
   public class CodeDefineExpression : DefineExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.Configuration.TopLevelPushCode && (interpreter.CodeStack.Count < 2)) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.Configuration.TopLevelPushCode && (interpreter.CodeStack.Count < 2)) return false;
 
       this.Eval(
@@ -41,4 +43,6 @@
 
       interpreter.CodeStack.Pop();
+
+      return true;
     }
   }
@@ -46,8 +50,8 @@
   [PushExpression(StackType.Exec, "EXEC.DEFINE")]
   public class ExecDefineExpression : DefineExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      if (interpreter.ExecStack.Count < 2) return;
+    public override bool Eval(IPushInterpreter interpreter) {
+      if (interpreter.ExecStack.Count < 2) return false;
 
-      this.Eval(
+      var noop = this.Eval(
         interpreter.ExecStack,
         interpreter.NameStack,
@@ -55,5 +59,8 @@
         v => new ExecPushExpression(v));
 
-      interpreter.ExecStack.Pop();
+      if (!noop)
+        interpreter.ExecStack.Pop();
+
+      return noop;
     }
   }
@@ -62,6 +69,6 @@
   public class FloatDefineExpression : DefineExpression<double> {
 
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(
         interpreter.FloatStack,
         interpreter.NameStack,
@@ -73,6 +80,6 @@
   [PushExpression(StackType.Integer, "INTEGER.DEFINE")]
   public class IntegerDefineExpression : DefineExpression<long> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(
         interpreter.IntegerStack,
         interpreter.NameStack,
@@ -84,6 +91,6 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.DEFINE")]
   public class BooleanDefineExpression : DefineExpression<bool> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(
         interpreter.BooleanStack,
         interpreter.NameStack,
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoCountExpressions.cs	(revision 14744)
@@ -47,6 +47,6 @@
     public CodeDoCountExpression(LoopState state) : base(state) { }
 
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter, interpreter.CodeStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter, interpreter.CodeStack);
     }
 
@@ -75,6 +75,6 @@
     public ExecDoCountExpression(LoopState state) : base(state) { }
 
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter, interpreter.ExecStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter, interpreter.ExecStack);
     }
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoRangeExpressions.cs	(revision 14744)
@@ -52,6 +52,6 @@
 
     public CodeDoRangeExpression(LoopState state) : base(state) { }
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter, interpreter.CodeStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter, interpreter.CodeStack);
     }
 
@@ -90,6 +90,6 @@
 
     public ExecDoRangeExpression(LoopState state) : base(state) { }
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter, interpreter.ExecStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter, interpreter.ExecStack);
     }
     protected override LoopExpression Clone(LoopState state) {
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DoTimesExpressions.cs	(revision 14744)
@@ -12,9 +12,4 @@
 
     protected override LoopState InitState(IPushInterpreter interpreter, IStack<Expression> sourceStack) {
-      //this.State.Body = sourceStack.Pop();
-      //this.State.DestinationIndex = interpreter.IntegerStack.Pop();
-      //this.State.CurrentIndex = 1;
-      //this.State.Incrementor = 1;
-
       return new LoopState(
         body: sourceStack.Pop(),
@@ -47,6 +42,6 @@
     public CodeDoTimesExpression(LoopState state) : base(state) { }
 
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter, interpreter.CodeStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter, interpreter.CodeStack);
     }
 
@@ -70,6 +65,6 @@
     public ExecDoTimesExpression(LoopState state) : base(state) { }
 
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter, interpreter.ExecStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter, interpreter.ExecStack);
     }
 
Index: branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs
===================================================================
--- branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs	(revision 14733)
+++ branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/DuplicateExpressions.cs	(revision 14744)
@@ -10,16 +10,19 @@
   /// <typeparam name="T">Stacktype</typeparam>
   public abstract class DuplicateExpression<T> : StatelessExpression {
-    protected void Eval(IStack<T> stack) {
-      if (stack.Count == 0) return;
+    protected bool Eval(IStack<T> stack) {
+      if (stack.Count == 0) return false;
 
       stack.Push(stack.Top);
+
+      return true;
     }
 
-    protected void Eval(IStack<Expression> stack) {
-      if (stack.Count == 0) return;
+    protected bool Eval(IStack<Expression> stack) {
+      if (stack.Count == 0) return false;
 
       var top = stack.Top;
 
       stack.Push(top);
+      return true;
     }
   }
@@ -27,6 +30,6 @@
   [PushExpression(StackType.Integer, "INTEGER.DUP")]
   public class IntegerDuplicateExpression : DuplicateExpression<long> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.IntegerStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter.IntegerStack);
     }
   }
@@ -34,6 +37,6 @@
   [PushExpression(StackType.Float, "FLOAT.DUP")]
   public class FloatDuplicateExpression : DuplicateExpression<double> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.FloatStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter.FloatStack);
     }
   }
@@ -41,6 +44,6 @@
   [PushExpression(StackType.Boolean, "BOOLEAN.DUP")]
   public class BooleanDuplicateExpression : DuplicateExpression<bool> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.BooleanStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter.BooleanStack);
     }
   }
@@ -48,6 +51,6 @@
   [PushExpression(StackType.Name, "NAME.DUP")]
   public class NameDuplicateExpression : DuplicateExpression<string> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.NameStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter.NameStack);
     }
   }
@@ -55,6 +58,6 @@
   [PushExpression(StackType.Exec, "EXEC.DUP")]
   public class ExecDuplicateExpression : DuplicateExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.ExecStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter.ExecStack);
     }
   }
@@ -62,6 +65,6 @@
   [PushExpression(StackType.Code, "CODE.DUP")]
   public class CodeDuplicateExpression : DuplicateExpression<Expression> {
-    public override void Eval(IPushInterpreter interpreter) {
-      this.Eval(interpreter.CodeStack);
+    public override bool Eval(IPushInterpreter interpreter) {
+      return this.Eval(interpreter.CodeStack);
     }
   }
